{{define "user/link"}}
<a href="/uid/user/{{.UserID}}/view">{{.Username}}</a>
{{end}}

{{define "user/item-full"}}
<div class="container flex-column">
  {{if and (not .Display.IsVerified) (not .Display.IsAdmin) .RequireVerification}}
  <div class="alert alert-warning">Account verification is now required to create or edit sessions.</div>
  {{end}}
  {{$VcodeSent := .VcodeSent}}
  {{with .Display}}
  <h5>{{template "user/link" .}}</h5>
  {{if .Profile}}
    {{if .Profile.RealName}}
    <div>Name: {{.Profile.RealName}}</div>
    {{end}}
    {{if .Profile.Email}}
    <div>Email: {{.Profile.Email}}</div>
    {{end}}
    {{if .Profile.Company}}
    <div>Company / Affiliation: {{.Profile.Company}}</div>
    {{end}}
    {{if .Description}}
    <div>Description: {{.Description}}</div>
    {{end}}
    {{if .MayEdit}}
    <div>Default Timezone: {{.DefaultLocation}}</div>
    <div class="m-1"><a href="edit" class="btn btn-primary" role="button">Edit</a>
    {{if .IsAdmin}}
    <a href="delete" class="btn btn-danger" role="button">Delete</a>
    {{end}}
    </div>
      {{if and (not .IsVerified) (not .IsAdmin)}}
      <div class="m-1"> This account is unverified.  New sessions and
	edits to existing sessions will be moderated (visible only to
	you and the administrators) to prevent spam.  After event
	registration is finalized, you will be sent a verification
	code.  Enter that code below to verify your account. </div>
      <div class="m-1">
	<form action="verify" method="POST">
          <div class="form-inline">
	    <label for="vcode"{{if not $VcodeSent}}class="text-muted"{{end}}>Verification Code</label>
	    <input type="text" name="Vcode" id="vcode" class="form-control mx-2">
	    <input type="submit" value="Verify" class="btn btn-primary mx-2" {{if not $VcodeSent}}disabled{{end}}>
	    {{if not $VcodeSent}}<span class="mx-2 text-muted font-italic">Note: Verifcation code hasn't been sent yet</span>{{end}}
	  </div>
	</form>
      </div>
      {{end}}
    {{end}}
  {{else}}
    <div class="text-muted">Full profile information only available when logged in</div>
    {{end}}
  {{end}}
</div>
{{end}}

{{define "user/item-short"}}
<div class="container">
  <div class="row">
    {{with .User}}  
    <div class="col-sm"><h5>{{template "user/link" .}}</h5></div>
    <div class="col-sm">{{if .Profile}}{{if .Profile.RealName}}{{.Profile.RealName}}{{end}}{{end}}</div>
    <div class="col-sm">{{if .Profile}}{{if .Profile.Company}}{{.Profile.Company}}{{end}}{{end}}</div>
    {{end}}
    <div class="col-1">
      <div class="row">
      {{if .CurrentUser}}
        {{if .CurrentUser.IsAdmin}}
          <form action="/uid/user/{{.User.UserID}}/setverified" method="POST">
            <div class="form-check form-switch">
	      <input type="checkbox" class="form-check-input"
	       name="verified" value="{{.User.UserID}}" id="p{{.User.UserID}}"
	       {{if .User.IsVerified}} checked{{end}}
	       onChange="this.form.submit()">
	      <label class="form-check-label" for="p{{.User.UserID}}"> </label>
	      <input type="hidden" name="newvalue" value={{if .User.IsVerified}}"false"{{else}}"true"{{end}}>
	    </div>
	    <input type="submit" value="Set" class="btn btn-primary noscript">
	    <script>
	    $('.noscript').hide();
	    </script>
            {{with .redirectURL}}
            <input type="hidden" name="redirectURL" value="{{.}}">
            {{else}}
            <input type="hidden" name="redirectURL" value="/list/user#{{.User.UserID}}">
            {{end}}
	  </form>
	{{end}}
	{{if .CurrentUser.IsAdmin}}
	{{if .User.IsVerified}}
	  <span class="badge bg-primary">Verified</span>
	{{else}}
	  <span class="badge bg-danger">Not Verified</span>
	{{end}}
	{{end}}
      {{end}}
      </div>
    </div>
  </div>
</div>
{{end}}

{{define "user/view"}}
<div class="row">
  <div class="col-9 col-offset-3">
      {{template "user/item-full" dict "Display" .Display "RequireVerification" .RequireVerification "VcodeSent" .IsVcodeSent}}
    {{$redirectURL := printf "/uid/user/%s/view" .Display.UserID}}
    {{template "discussion/list" dict "List" .Display.List "redirectURL" $redirectURL "CurrentUser" .CurrentUser}}
  </div>
</div>
{{end}}

{{define "user/list"}}
<ul class="list-group">
  {{$CurrentUser := .CurrentUser}}
  {{range .List}}
  <li class="list-group-item">{{template "user/item-short" dict "User" . "CurrentUser" $CurrentUser}}</li>
  {{else}}
  <p>No users registered yet</p>
  {{end}}
</ul> 
{{end}}

{{define "user/profile/form"}}
		<h4>Profile information (optional)</h4>
		
		<p><details class="text-muted"><summary>How is this
		used?</summary>The following information is optional.
		It will be visible on this website to anyone else
		logged in, to help people connect with you at the
		conference.  It may also be archived with the schedule
		for future reference.</details></p>

		<div class="form-group">
		  <label for="newName">Name</label>
		  <input type="text" name="RealName" id="newName" value ="{{.RealName}}" class="form-control" placeholder="e.g., John Smith" autocomplete="name">
		</div>
		<div class="form-group">
			<label for="newCompany">Company / Affiliation</label>
			<input type="text" name="Company" value="{{.Company}}" id="newCompany" class="form-control" placeholder="XYZ Corporation, Ltd" autocomplete="organization work">
		</div>
		<div class="form-group">
			<label for="newDescription">Description</label>
			<textarea name="Description" id="newProfile" class="form-control"
		         placeholder="Breifly describe who you are, what you do, and what you're looking for from the conference">{{.Description}}</textarea>
		</div>

{{end}}

{{define "user/edit"}}
<div class="row">
	<div class="col-md-6 col-md-offset-3">
		<h1>Editing user {{.Display.Username}}</h1>
		{{with .Error}}
		<div class="alert error">
			{{.}}
		</div>
		{{end}}
		<form action="edit" method="POST">
			<h4>Change Password <small>optional</small></h4>
			<div class="form-group">
				<label for="currentPassword">Current Password</label>
				<input type="password" name="currentPassword" id="currentPassword" class="form-control" autocomplete="current-password">
			</div>
			<div class="form-group">
				<label for="newPassword">New Password</label>
				<input type="password" name="newPassword" id="newPassword" class="form-control" autocomplete="new-password">
			</div>
			<div class="form-group">
			  <label for="newEmail">Email (Optional)</label>
			  <input type="email" name="Email" value="{{.Display.Profile.Email}}" id="newEmail" class="form-control" placeholder="name@example.com" autocomplete="email work">
			</div>
                        <div class="form-group">
                          <label for="location">Default timezone: </label>
                          <select name="Location" id="location" class="form-control">
                          {{template "schedule/form-location-option" .Display.DefaultLocation}}
                          {{range .Locations}}
                          {{template "schedule/form-location-option" .}}
                          {{end}}
                          </select>
                        </div>
			{{template "user/profile/form" .Display.Profile}}
			<input type="submit" value="Save" class="btn btn-primary">
		</form>
	</div>
</div>
{{end}}

{{define "user/delete"}}
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <h1>Delete user</h1>
    <div class="m-1">Really delete user "{{.Display.Username}}" and all their sessions?</div>
    <form action="delete" method="POST">
    <input type="submit" value="Delete" class="btn btn-danger">
    </form>
  </div>
</div>
{{end}}

{{define "user/new"}}
<div class="col-md-6 col-md-offset-3">
  <h1>Sign Up</h1>
  {{if .Error}}
    <p class="text-danger">
    {{.Error}}
    </p>
  {{end}}
  <form action="/register" method="POST">
    <div class="form-group">
      <label for="newUsername">Username</label> (Required)
      <input type="text" name="Username" value="{{.Username}}" id="newUsername" class="form-control" autocomplete="username">
    </div>
    <div class="alert alert-primary">Usernames are displayed
	publicly on discussion proposals, as well as on an "attendee
	list", even if a user doesn't propose any discussions.</div>
    <div class="form-group">
      <label for="newEmail">Email (Optional)</label>
      <input type="email" name="Email" value="{{.Profile.Email}}" id="newEmail" class="form-control" placeholder="name@example.com" autocomplete="email work">
    </div>
    <div class="form-group">
      <label for="newPassword">Password</label>
      <input type="password" name="Password" id="newPassword" class="form-control" autocomplete="new-password">
    </div>
    {{if .RequireVerification}}
    <div class="form-group">
      <label for="vcode">Verification Code</label>
      <input type="text" name="Vcode" id="vcode" class="form-control">
      <p class="text-muted">Please contact community.manager@xenproject.org if you haven't received a verification code</p>
    </div>
    {{end}}
    <div class="form-group">
      <label for="location">Default timezone: </label>
      <select name="Location" id="location" class="form-control">
        {{template "schedule/form-location-option" .DefaultLocation}}
        {{range .Locations}}
        {{template "schedule/form-location-option" .}}
        {{end}}
      </select>
    </div>
    {{template "user/profile/form" .Profile}}
    <input type="submit" value="Register" class="btn btn-primary">
  </form>
</div>
{{end}}

